/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	COMǗ@\
 */

#include "com_memory.h"

/*--------------------------------------------------------------------
 * Tv      Fobt@Zbg֐
 * @\      Fw肳ꂽŃobt@ɃZbg.
 * (in)  F<c>         Zbg镶
 *           F<count>     oCg 
 *     (out) F<dest>      i[AhX
 * ߂l    Fi[AhX
 * l      FȂ
 *------------------------------------------------------------------*/
VP
com_local_memset (VP dest, UINT8 c, UINT32 count)
{
	UINT8 *memset_pos = dest;

	while (((UINT32) 0) < count) {
		*memset_pos = c;
		memset_pos++;
		count--;
	}
	
	return dest;
}

/*--------------------------------------------------------------------
 * Tv      Fobt@Rs[֐
 * @\      Fw肳ꂽoCgAobt@ɃRs[D
 * (in)  F<src>       Rs[AhX
 *           F<count>     oCg
 *     (out) F<dest>      Rs[AhX
 * ߂l    FRs[AhX
 * l      FȂ
 *------------------------------------------------------------------*/
VP
com_local_memcpy (VP dest, VP src, UINT32 count)
{
	INT8 *dest_pos = dest;
	INT8 *src_pos = src;

	while (((UINT64) 0) < count) {
		*dest_pos = *src_pos;
		dest_pos++;
		src_pos++;
		count--;
	}
	return dest;
}

