/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	^C}@\
 */

#ifndef _COM_TIMER_H_
#define _COM_TIMER_H_

/* AvEiʒ` */
#include "com_timer_user.h"

/*
 *  ^C}ID̓Ȓl̒`
 */
#define TIMID_NULL			((TimerType) UINT8_INVALID)		/* ID */
#define TNUM_COM_COUNTER	1

/*
 *  COMJE^ID`
 *
 *  SGo͂ĂȂ߁C COMɂID`sD
 */
#define COM_COUNTER_ID		((TickCounterType)0)

/*
 *  COMJE^E^C}ێϐ̐錾
 *
 *  NMƃ[J^C}L\lĊOϐƂD
 */
extern const UINT8	tnum_tick;								/* eBbN̐iCOM etc.j	*/

/*
 *  COMJE^ubN
 */
extern const TimerTickType	tickinib_maxval[TNUM_COM_COUNTER];		/* JE^̍ől		TICKCOUNTER.MAXALLOWEDVALUE	*/
extern const TimerTickType	tickinib_tickbase[TNUM_COM_COUNTER];	/* 1ŐiރeBbN	TICKCOUNTER.TICKSPERBASE	*/
extern const TimerTickType	tickinib_mincyc[TNUM_COM_COUNTER];		/* ̍ŏl			TICKCOUNTER.MINCYCLE		*/

/*
 *  COMJE^ǗubN
 */
extern TimerTickType		tickcb_curval[TNUM_COM_COUNTER];		/* JE^̌݃eBbN 	*/
extern TimerType			tickcb_timque[TNUM_COM_COUNTER];		/* ^C}̃L[			*/

#endif /* _COM_TIMER_H_ */
