/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	OSEK COM WCN[ht@C
 *
 *  ̃CN[ht@ĆCCOM\vÕ\[Xt@
 *  CŕKCN[hׂWCN[ht@CłD
 *
 *  AZũ\[Xt@CVXeRtBM[Vt@
 *  C炱̃t@CCN[h鎞́C_MACRO_ONLY `
 *  ƂŁC}N`ȊŐLqƂłD
 */
#ifndef _OSEK_COM_H_
#define _OSEK_COM_H_

#include "com.h"
#include "ul.h"
#include "com_tool_config.h"

/*
 *  OS̋@\𗘗p邽߁C
 *  TOPPERS/OSEK OS ̕WCN[ht@CǂݍށD
 */
#include "kernel.h" 

/*
 *  COMŎgpf[^^̒`
 */
#ifndef _MACRO_ONLY
typedef void	*VP;			/* ^܂Ȃ̂ւ̃|C^ */
typedef void	(*FP)(void);	/* vŐNԒni|C^j */
#endif

/* Rs[֐̋NԒni|C^j */
typedef void	(*COPYFP)(ApplicationDataRef p_dst, ApplicationDataRef p_src);

/* R[AEg֐ւ̃|C^ */
typedef CalloutReturnType	(*CALLOUTFP)(void);

/* tB^֐̃|C^ */
typedef StatusType			(*FILTFP)(ApplicationDataRef p_in);

/* tB^֐ւ̃|C^ */
typedef void				(*INIFILTFP)(ApplicationDataRef p_in);

/*
 *  ʓIȒ萔̒`
 */
#define	NULL			((void *) 0)	/* |C^ */
#define FP_NULL			((FP) 0)		/* ֐|C^ */
#define	COPYFP_NULL		((COPYFP) 0)	/* Rs[֐|C^ */
#define	CALLOUTFP_NULL	((CALLOUTFP) 0)	/* R[AEg֐|C^ */
#define	FILTFP_NULL		((FILTFP) 0)	/* tB^֐|C^ */
#define	INIFILTFP_NULL	((INIFILTFP) 0)	/* tB^֐|C^ */

/*
 *  O[oϐ̒`
 */
extern COMApplicationModeType	comappmode;		/* COMAvP[V[h */

/* StopCOMŐݒ肳ȊOgp邱Ƃ̂ȂϐD	*/
/* sȂɃ[UQƂ邱ƂȂD	*/
/* dlɋLq邽߁C쐬Ă邪				*/
/* KviKł͌ĂȂ					 	*/
extern COMShutdownModeType		comstopmode;	/* COMVbg_E[h */

/* comcallevel̏ ̂`ꍇCOMCL_STOPŏ */
extern UINT8		comcallevel;

/*
 *  ŗLϐ̒`
 */
#define	RCV_IPDU_BUF_ADD	(1)		/* Mf[^󂯓nGAm  W		*/
									/* Kv+1  ŁCsǊĎGAm	*/

/*
 *  COM֐̃vg^Cv錾
 */
/* AL[֐ */
extern void unque_init(void);

/* tO֐ */
extern void init_flags(void);

/* COMG[tbNĂяo֐ */
extern void call_com_errorhook(StatusType ercd, COMServiceIdType com_svcid);

/* IPDUփf[^i[ */
extern StatusType	update_Ipdu( MessageIdentifier msgid, const UINT8* p_msg, UINT8* p_ipdu );
extern StatusType	update_Ipdu_Dyna( MessageIdentifier msgid, const UINT8* p_msg, UINT8* p_ipdu, LengthRef p_len );

/* IPDUf[^擾 */
extern StatusType	update_Message( MessageIdentifier msgid, const UINT8* p_ipdu, UINT8* p_msg, const UINT32* p_bitlen );

/* oCgI[_ϊ */
extern StatusType	convert_byteorder( MessageIdentifier msgid, const UINT8* p_src, UINT8* p_dest );

/* IPDUM */
extern StatusType	RequestTransmission(IPDUType ipdu_id);

/* Mʏ(static)bZ[Wփf[^i[ */
extern StatusType	SetRcvMsg(MessageIdentifier msgid, ApplicationDataRef p_data);

/* MZeroMsgbZ[W֒ʒm */
extern StatusType	SetRcvZeroMsg(MessageIdentifier msgid);

/* IL̒ʒm󂯌 */
extern void	il_snd_fin_func(IPDUType ipdu_id);
extern void	il_snd_err_func(IPDUType ipdu_id,StatusType err_status);
extern void	il_rcv_fin_func(IPDUType ipdu_id);
extern void	il_rcv_err_func(IPDUType ipdu_id, StatusType err_status);

/* MOłIPDUփf[^i[Ȁ */
extern StatusType SetSndExTrigNorm (MessageIdentifier msgid, ApplicationDataRef p_data, IPDUType *p_ipduid);
extern StatusType SetSndExPendNorm (MessageIdentifier msgid, ApplicationDataRef p_data);
extern StatusType SetSndExTrigDyna (MessageIdentifier msgid, ApplicationDataRef p_data, LengthRef p_len, IPDUType *p_ipduid);
extern StatusType SetSndExPendDyna (MessageIdentifier msgid, ApplicationDataRef p_data, LengthRef p_len);

/* M̃fbhCj^O  ^CAEg̏ */
extern void	rcv_deadline_timeup(UINT8 ipdu_id);

/*
 * bZ[WIDʂ̒`
 */
#define	MSG_RCV_NORM	((MessageIdentifier)0x0400)	/* M-L[-ʏ */
#define	MSG_RCV_ZERO	((MessageIdentifier)0x0800)	/* (ORw肵ĕύX)M-[OX */
#define	MSG_RCV_DYNA	((MessageIdentifier)0x0c00)	/* (ORw肵ĕύX)M-_Ci~bN */
#define	MSG_RCV_QUED	((MessageIdentifier)0x0200)	/* (ORw肵ĕύX)L[L */
#define	MSG_RCV_IPDU	((MessageIdentifier)0x0100)	/* (ORw肵ĕύX)IPDUobZ[W */
#define	MSG_SND_NORM	((MessageIdentifier)0x4000)	/* M-ʐM-ʏ */
#define	MSG_SND_ZERO	((MessageIdentifier)0x8000)	/* (ORw肵ĕύX)M-gK-[OX */
#define	MSG_SND_DYNA	((MessageIdentifier)0xc000)	/* (ORw肵ĕύX)M-gK-_Ci~bN */
#define	MSG_SND_EXT		((MessageIdentifier)0x1000)	/* (ORw肵ĕύX)OʐM */
#define	MSG_SND_PEND	((MessageIdentifier)0x2000)	/* (ORw肵ĕύX)yfBO */

/*
 * ʔp}XNl
 */
#define	MSG_RCV_MASK	((MessageIdentifier)0x0f00)	/* MbZ[Wʔp}XNl */
#define	MSG_SND_MASK	((MessageIdentifier)0xf000)	/* MbZ[Wʔp}XNl */

/*
 * bZ[WID̘Aԕop}XNl
 */
#define	MSG_ID_MASK		((MessageIdentifier)0x00ff)

/*
 * ID
 */
#define	MSG_NULL		((MessageIdentifier)0xffff)
#define	IPDU_NULL		((IPDUType)0xff)

/*
 * rbgI[_[
 */
#define	COM_BITLITTLE	0
#define	COM_BITBIG		1

/*
 * IPDUM[h
 */
#define	COM_IPDU_DIRECT		((UINT8)0)
#define	COM_IPDU_PERIODIC	((UINT8)1)
#define	COM_IPDU_MIXED		((UINT8)2)

/*
 * IPDUMvtOl
 */
#define	IPDU_NO_REQUEST		((UINT8)0x00)
#define	IPDU_SEND_REQUEST	((UINT8)0x01)
#define	IPDU_SENDING		((UINT8)0x02)

/*
 * ł̃G[R[h
 */
#define E_IPDU_NOREQUEST	((StatusType) 53)
#define E_IPDU_SENDING		((StatusType) 54)
#define E_IPDU_STOP			((StatusType) 56)
#define	E_IL_FILTERED		((StatusType) 55) /* tB^ŃJbgꂽ */
#define E_IL_SIZEOVER		((StatusType) 57) /* CDATATYPẼTCYI[o[ */
#define E_IL_CALLOUTFALSE	((StatusType) 58) /* CalloutɂĈȍ~̏f */

/*
 * CANhCoDLC
 */
#define CAN_DATA_DLC_DRV (8)

/*
 * ȉ com_cfg.c ɂďo͂f[^extern錾
 */
/* IuWFNg */
extern const UINT8 tnum_rcv_unq_norm;
extern const UINT8 tnum_rcv_unq_zero;
extern const UINT8 tnum_rcv_unq_dyna;
extern const UINT8 tnum_rcv_que_norm;
extern const UINT8 tnum_rcv_ipdu_norm;
extern const UINT8 tnum_rcv_ipdu_zero;
extern const UINT8 tnum_rcv_ipdu_dyna;
extern const UINT8 tnum_snd_in_norm;
extern const UINT8 tnum_snd_in_zero;
extern const UINT8 tnum_snd_ex_trig_norm;
extern const UINT8 tnum_snd_ex_pend_norm;
extern const UINT8 tnum_snd_ex_trig_zero;
extern const UINT8 tnum_snd_ex_trig_dyna;
extern const UINT8 tnum_snd_ex_pend_dyna;

/* MbZ[WIuWFNgiUNQUEUEDj obt@̈ */
extern const ApplicationDataRef msgbuf_rcv_unq_norm[];
extern const ApplicationDataRef msgbuf_rcv_unq_zero[];
extern const ApplicationDataRef msgbuf_rcv_unq_dyna[];

/* MbZ[WIuWFNgiUNQUEUEDj obt@TCY */
extern const UINT32 msgsize_rcv_unq_norm[];
extern const UINT32 msgsize_rcv_unq_dyna[];

/* M̃_Ci~bNbZ[W̍őTCY */
extern const UINT32 msgsize_snd_ex_trig_dyna[];
extern const UINT32 msgsize_snd_ex_pend_dyna[];

/* _Ci~bNbZ[W̃f[^ێ邽 */
extern const LengthRef msglength_rcv_unq_dyna[];

/* MbZ[WIuWFNgiQUEUED֘A`j */
extern const UINT8 tnum_que_elem[];
extern const ApplicationDataRef msgbuf_head_que_norm[];
extern const ApplicationDataRef msgbuf_end_que_norm[];
extern const UINT32 msgsize_que_norm[];
extern UINT8 msgque_cnt[];
extern ApplicationDataRef msgque_get_addr[];
extern ApplicationDataRef msgque_put_addr[];

/* bZ[Wf[^Rs[֐ */
extern const COPYFP copyfunc_rcv_unq_norm[];
extern const COPYFP copyfunc_rcv_que_norm[];
extern const COPYFP copyfunc_snd_ex_trig_norm[];
extern const COPYFP copyfunc_snd_ex_pend_norm[];

/* tB^֐ */
extern const FILTFP		filter_rcv_unq_norm[];
extern const INIFILTFP	filter_init_rcv_unq_norm[];
extern const FILTFP		filter_rcv_que_norm[];
extern const INIFILTFP	filter_init_rcv_que_norm[];
extern const FILTFP		filter_snd_ex_trig_norm[];
extern const INIFILTFP	filter_init_snd_ex_trig_norm[];
extern const FILTFP		filter_snd_ex_pend_norm[];
extern const INIFILTFP	filter_init_snd_ex_pend_norm[];

extern const UINT64 initialvalue_rcv_unq_norm[];
extern const UINT64 initialvalue_rcv_unq_dyna[];
extern const UINT64 initialvalue_rcv_que_norm[];
extern const UINT64 initialvalue_snd_ex_trig_norm[];
extern const UINT64 initialvalue_snd_ex_pend_norm[];
extern const UINT64 initialvalue_snd_ex_trig_dyna[];
extern const UINT64 initialvalue_snd_ex_pend_dyna[];

/* M  IPDUbZ[WƎMbZ[W̑Ή */
extern const MessageIdentifier *  sndlist_rcv_ipdu_norm[];
extern const MessageIdentifier sndlist_rcv_ipdu_zero[];
extern const MessageIdentifier *  sndlist_rcv_ipdu_dyna[];
extern const MessageIdentifier *  sndlist_snd_in_norm[];
extern const MessageIdentifier *  sndlist_snd_in_zero[];

/* oCgI[_[ϊf */
extern const UINT8 byteorder_snd_ex_trig_norm[];
extern const UINT8 byteorder_snd_ex_pend_norm[];
extern const UINT8 byteorder_rcv_ipdu_norm[];

/* IPDUobt@̈ */
extern UINT8* const msgbuf_snd_ipdu[];
extern UINT8* const msgbuf_rcv_ipdu[];

/* IPDUIuWFNg */
extern const UINT8 tnum_snd_ipdu;	/* IPDUMf[^ */
extern const UINT8 tnum_rcv_ipdu;	/* IPDUMf[^ */

/* M  IPDU */
extern const MessageIdentifier *sndlist_snd_ipdu[];
extern const UINT32 bitsize_snd_ipdu[];
extern const UINT32 bytesize_snd_ipdu[];
extern const UINT64 timeperiod_snd_ipdu[];
extern const UINT64 timeoffset_snd_ipdu[];
extern const UINT64 timeout_snd_ipdu[];
extern const UINT64 firsttimeout_snd_ipdu[];
extern const UINT64 delaytime_snd_ipdu[];
extern const UINT8 * layerused_snd_ipdu[];
extern const UINT8 transmode_snd_ipdu[];

/* M  IPDU */
extern const MessageIdentifier *sndlist_rcv_ipdu[];
extern const UINT32 bitsize_rcv_ipdu[];
extern const UINT32 bytesize_rcv_ipdu[];
extern const UINT64 timeout_rcv_ipdu[];
extern const UINT64 firsttimeout_rcv_ipdu[];
extern const UINT8 * layerused_rcv_ipdu[];

/* M  bZ[WEIPDU֘A */
extern const IPDUType ipduid_snd_ex_trig_norm[];
extern const UINT32 bitsize_snd_ex_trig_norm[];
extern const UINT32 offset_snd_ex_trig_norm[];
extern const UINT8 bitorder_snd_ex_trig_norm[];
extern const IPDUType ipduid_snd_ex_pend_norm[];
extern const UINT32 bitsize_snd_ex_pend_norm[];
extern const UINT32 offset_snd_ex_pend_norm[];
extern const UINT8 bitorder_snd_ex_pend_norm[];
extern const IPDUType ipduid_snd_ex_trig_zero[];
extern const IPDUType ipduid_snd_ex_trig_dyna[];
extern const UINT32 offset_snd_ex_trig_dyna[];
extern const UINT8 bitorder_snd_ex_trig_dyna[];
extern const UINT32 bitsize_snd_ex_trig_dyna[];
extern const IPDUType ipduid_snd_ex_pend_dyna[];
extern const UINT32 offset_snd_ex_pend_dyna[];
extern const UINT8 bitorder_snd_ex_pend_dyna[];
extern const UINT32 bitsize_snd_ex_pend_dyna[];

/* M  IPDUbZ[W */
extern const UINT32 bitsize_rcv_ipdu_norm[];
extern const UINT32 bitsize_rcv_ipdu_dyna[];
extern const UINT32 bytesize_rcv_ipdu_norm[];
extern const UINT32 bytesize_rcv_ipdu_dyna[];
extern const UINT32 offset_rcv_ipdu_norm[];
extern const UINT32 offset_rcv_ipdu_dyna[];
extern const UINT8 bitorder_rcv_ipdu_norm[];
extern const UINT8 bitorder_rcv_ipdu_dyna[];

/* Notification֐e[uEtOZbg֐e[u */
extern const FP notification1_rcv_unq_norm[];
extern const FP notification1_rcv_unq_zero[];
extern const FP notification1_rcv_unq_dyna[];
extern const FP notification1_rcv_que_norm[];
extern const FP resetflag1_rcv_unq_norm[];
extern const FP resetflag1_rcv_unq_zero[];
extern const FP resetflag1_rcv_unq_dyna[];
extern const FP resetflag1_rcv_que_norm[];

extern const FP notification2_snd_ex_trig_norm[];
extern const FP notification2_snd_ex_pend_norm[];
extern const FP notification2_snd_ex_trig_zero[];
extern const FP notification2_snd_ex_trig_dyna[];
extern const FP notification2_snd_ex_pend_dyna[];
extern const FP resetflag2_snd_ex_trig_norm[];
extern const FP resetflag2_snd_ex_pend_norm[];
extern const FP resetflag2_snd_ex_trig_zero[];
extern const FP resetflag2_snd_ex_trig_dyna[];
extern const FP resetflag2_snd_ex_pend_dyna[];

extern const FP notification3_rcv_unq_norm[];
extern const FP notification3_rcv_unq_zero[];
extern const FP notification3_rcv_unq_dyna[];
extern const FP notification3_rcv_que_norm[];
extern const FP resetflag3_rcv_unq_norm[];
extern const FP resetflag3_rcv_unq_zero[];
extern const FP resetflag3_rcv_unq_dyna[];
extern const FP resetflag3_rcv_que_norm[];

extern const FP notification4_snd_ex_trig_norm[];
extern const FP notification4_snd_ex_pend_norm[];
extern const FP notification4_snd_ex_trig_zero[];
extern const FP notification4_snd_ex_trig_dyna[];
extern const FP notification4_snd_ex_pend_dyna[];
extern const FP resetflag4_snd_ex_trig_norm[];
extern const FP resetflag4_snd_ex_pend_norm[];
extern const FP resetflag4_snd_ex_trig_zero[];
extern const FP resetflag4_snd_ex_trig_dyna[];
extern const FP resetflag4_snd_ex_pend_dyna[];

/* R[AEg֐ */
extern const CALLOUTFP callout_cpuorder_rcv_ipdu_norm[];
extern const CALLOUTFP callout_netorder_rcv_ipdu_norm[];
extern const CALLOUTFP callout_cpuorder_rcv_ipdu_zero[];
extern const CALLOUTFP callout_netorder_rcv_ipdu_zero[];
extern const CALLOUTFP callout_cpuorder_rcv_ipdu_dyna[];
extern const CALLOUTFP callout_netorder_rcv_ipdu_dyna[];
extern const CALLOUTFP callout_cpuorder_snd_ex_trig_norm[];
extern const CALLOUTFP callout_netorder_snd_ex_trig_norm[];
extern const CALLOUTFP callout_cpuorder_snd_ex_pend_norm[];
extern const CALLOUTFP callout_netorder_snd_ex_pend_norm[];
extern const CALLOUTFP callout_cpuorder_snd_ex_trig_zero[];
extern const CALLOUTFP callout_netorder_snd_ex_trig_zero[];
extern const CALLOUTFP callout_cpuorder_snd_ex_trig_dyna[];
extern const CALLOUTFP callout_netorder_snd_ex_trig_dyna[];
extern const CALLOUTFP callout_cpuorder_snd_ex_pend_dyna[];
extern const CALLOUTFP callout_netorder_snd_ex_pend_dyna[];
extern const CALLOUTFP callout_rcv_ipdu[];
extern const CALLOUTFP callout_snd_ipdu[];

/* M[Nϐ */
extern UINT32 msgbuf_snd_tmp[];
extern UINT32 msgbuf_snd_after_swapbytes[];
extern const UINT8 msgsize_snd_ex_trig_norm[];
extern const UINT8 msgsize_snd_ex_pend_norm[];
extern UINT8 flg_snd_ipdu[];
extern UINT8 ipdu_snd_dlc[];

/* TCY`FbNɕKv */
extern const UINT32 bytesize_snd_max;	/* M[Nϐ̃TCY */
extern const UINT32 bytesize_rcv_max;	/* M[Nϐ̃TCY */

/* M[Nϐ */
extern UINT32 ipdubuf_rcv_tmp[];
extern UINT32 msgbuf_rcv_ipdu_tmp[];
extern UINT32 msgbuf_rcv_after_swapbytes[];

#endif /* _OSEK_COM_H_ */
