/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑVAIOW[iS810-CLG3-85pj
 */

/*
 *  KD3083 gp( USE_KD3083 `) KD3083  UART1 gp邽߁C
 *  VAIOW[͓삳ȂD
 *  UART0 gp͂邪COILt@CɋLڂĂ銄݃Gg[
 *  ԍRpCIvV( USE_KD3083 )Őؑւ悢@Ȃ߁C
 *  UART0 gp͍sȂD
 */

#include	"hw_serial.h"


/*
 *  VAIOW[
 *
 *  ݋֎~ԂŌďoƁD
 */
void
InitHwSerial( void )
{
#if !defined( USE_KD3083 )
	/*
	 *  M֎~ĊeWX^ݒ
	 */
	TE_U1C1 = 0;	/* M֎~	*/
	RE_U1C1 = 0;	/* M֎~	*/

	/*
	 *  IO|[gVA|[gɕύX
	 */
	PS0_7 = 1;/* |[gP67 TxD1 	*/
	PD6_6 = 0;/* |[gP66  	*/
	PS0_6 = 0;/* |[gP66 RxD1 	*/

	/*
	 *  NbNgp, 񓯊ʐM, 8rbgf[^,
	 *  peBȂ, X[vȂ, NbNf1, CTS/RTS֎~
	 */
	U1MR = (UINT8)( 0x05 );
	CLK0_U1C0 = 0;
	CLK1_U1C0 = 0;
	CRD_U1C0 = 1;

	/*
	 *  {[[gݒiݒl̓wb_QƁj
	 */
	U1BRG = CFG_BRG_SERIAL;

	/*
	 *  M݃xݒiݒ背x̓wb_QƁj
	 *  S1RIC  bit3 ݗvtOłCɃNAĂD
	 *
	 *  M݂͎gpȂD
	 */
	S1RIC = CFG_INTLVL_SERIAL_RX;

	RE_U1C1 = 1;	/* M */
	TE_U1C1 = 1;	/* M */
#endif	/* USE_KD3083	*/
}	/* InitHwSerial	*/


/*
 *  VAIOW[~
 *
 *  ݋֎~ԂŌďoƁD
 *  ʂŏo͂Ă邱ƂۏႷ邱ƁD
 */
void
TermHwSerial( void )
{
#if !defined( USE_KD3083 )
	S1RIC = (UINT8)( 0 );	/* M݃}XN	*/
	S1TIC = (UINT8)( 0 );	/* M݃}XN	*/

	TE_U1C1 = 0;			/* M֎~			*/
	RE_U1C1 = 0;			/* M֎~			*/
#endif	/* USE_KD3083	*/
}	/* TermHwSerial	*/


/*
 *  VAIOW[M݃T[rX[`
 */
 #if defined( OMIT_ISR1_ENTRY )
/* ISR1͖{֐݊֐w肷	*/
#pragma INTERRUPT	RxHwSerialInt
#endif	/* OMIT_ISR1_ENTRY	*/
void	RxHwSerialInt( void );
void
RxHwSerialInt( void )
{
#if !defined( USE_KD3083 )
	UINT16	rx_data;	/* f[^Mobt@	*/

	/*
	 *  I[oh~̂߂܂Ǎ
	 */
	rx_data = U1RB;

	/*
	 *  M̓R[obNs
	 *  G[̓G[AiM֎~邱ƂŃG[tOOFFj
	 */
	if( ( rx_data & 0xff00 ) == 0 ){
		RxSerialInt( (UINT8)rx_data );
	}
	else{
		RE_U1C1 = 0;	/* M֎~ */
		RE_U1C1 = 1;	/* M */
	}
#endif	/* USE_KD3083	*/
}	/* RxHwSerialInt	*/


