/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑVAIOW[iS810-CLG3-85pj
 */

/*
 *  KD3083 gp( USE_KD3083 `) KD3083  UART1 gp邽߁C
 *  VAIOW[͓삳ȂD
 *  UART0 gp͂邪COILt@CɋLڂĂ銄݃Gg[
 *  ԍRpCIvV( USE_KD3083 )Őؑւ悢@Ȃ߁C
 *  UART0 gp͍sȂD
 */

#if !defined( _HW_SERIAL_H_ )
#define _HW_SERIAL_H_


#include	"kernel.h"
#include	"sfrm32c85.h"


/*
 *  VA|[g̊݃x`
 */
#define	CFG_INTLVL_SERIAL_RX	(UINT8)( 0x06 )	/* VAM */

/*
 *  VA|[g̃{[[g`
 *
 *  CFG_BRG_SERIAL ̒`ύXŃ{[[gύX\
 */
#define	BRG_SERIAL_9600		(UINT8)( 207 )	/* 32000000/{(UxBRG+1)*16} = 9615	*/
#define	BRG_SERIAL_19200	(UINT8)( 103 )	/* 32000000/{(UxBRG+1)*16} = 19230	*/
#define	BRG_SERIAL_38400	(UINT8)( 51 )	/* 32000000/{(UxBRG+1)*16} = 38461	*/
#define	BRG_SERIAL_57600	(UINT8)( 34 )	/* 32000000/{(UxBRG+1)*16} = 57142	*/
#define	CFG_BRG_SERIAL		BRG_SERIAL_38400


#if !defined( _MACRO_ONLY )

/*
 *  VXeOo̓W[֐vg^Cv錾
 */
extern void	InitHwSerial( void );

/*
 *  VXeOo̓W[~֐vg^Cv錾
 */
extern void	TermHwSerial( void );

/*
 *  ĂюwReLXgł̕M֐vg^Cv錾
 */
Inline void	PutHwChar( UINT8 character );

/*
 *  R[obN֐OQ
 */
extern void	RxSerialInt( UINT8 character );

/*
 *  ĂюwReLXgł̕MD
 *
 *  {֐͊݋֎~ԂŌĂяoƁD
 *  sR[hȂǂ̐R[hvōsƁD
 */
Inline void
PutHwChar( UINT8 character )
{
#if !defined( USE_KD3083 )
	/* Mobt@ɂȂ܂ő҂	*/
	while( TI_U1C1 == 0 );
	U1TB = (UINT16)(character);
#endif	/* USE_KD3083	*/
}	/* PutHwChar	*/

#endif /* _MACRO_ONLY */


#endif /* _HW_SERIAL_H_ */

