/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑVXe^C}W[iS810-CLG3-85pj
 */


#include	"hw_sys_timer.h"


/*
 *  VXe^C}̋N
 *
 *  ݋֎~ԂŌďoƁD
 */
void
InitHwSysTimer( void )
{
	/*
	 *  ^C}~ĊeWX^ݒ
	 */
	TA0S = 0;	/* JEg~	*/

	/*
	 *  ^C}A0_EJEg, ^C}[h, JEg\[Xf1
	 */
	TA0UD = (UINT8)( 0 );
	TA0MR = (UINT8)( 0 );

	/*
	 *  n[hEFAdlɂă^C}\[X̃WX^ݒl+1邽,
	 *  WX^ݒl̓VXeNbNɑJEg
	 *  }CiX1lݒ肷.iݒl̓wb_QƁj
	 */
	TA0 = CFG_SYSCLK - (UINT16)( 1 );

	/*
	 *  ^C}RyA݃xݒiݒ背x̓wb_QƁj
	 *  TA0IC  bit3 ݗvtOłCɃNAĂD
	 */
	TA0IC = CFG_INTLVL_SYSCLK;

	TA0S = 1;	/* JEgJn	*/
}	/* InitHwSysTimer	*/


/*
 *  VXe^C}̒~
 *
 *  ݋֎~ԂŌďoƁD
 */
void
TermHwSysTimer( void )
{
	TA0S = 0;					/* JEg~	*/
	TA0IC = (UINT8)( 0 );		/* ݃}XN	*/
}	/* TermHwSysTimer	*/


