/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑW[iS810-CLG3-85pj
 */


#include	"sample_config.h"
#include	"sfrm32c85.h"


/*
 *  OIL`V{̊OQ
 */
DeclareCounter( SampleCnt );


/*
 *	֐vg^Cv錾
 */
ISR( CounterInt );
ISR( HwCnt2Int );


/*
 *  AvP[V[hp
 */
/*
 *  AvP[V[hp̏擾
 *
 *  VXeƂɔCӂ͎̓@ɂ邱ƁD
 *  0,1,2ʂł邱ƁD32ƓɂȂD
 *
 *  s810-clg3-85łSW5|[g2bit0`bit7ɕs_HŎĂD
 *  ̂߁CSW5-8,SW5-7(|[g2bit0,bit1)͂ɂĎgpD
 */
UINT8
GetAppModeInfo( void )
{
	/*
	 *  |[g2bit0,bit1͂ɂD
	 */
	PD2_0 = 0;
	PD2_1 = 0;

	/*
	 *  _ŉ2bitǍ
	 */
	return (UINT8)( ~P2 & (UINT8)( 0x03 ) );
}	/* GetAppModeInfo	*/


/*
 *  TvJE^\[Xp
 *
 *  s810-clg3-85ł̓^C}A1ŎD
 */

/*
 *  SignalCounterspݏ
 *
 *  ^C}̋N͕ʊ֐ōsD
 */
void
InitCounterInt( void )
{
	/*
	 *  ^C}~ĊeWX^ݒ
	 */
	TA1S = 0;	/* JEg~	*/

	/*
	 *  ^C}A1_EJEg, ^C}[h, JEg\[Xf1
	 */
	TA1UD = (UINT8)( 0 );
	TA1MR = (UINT8)( 0 );

	/*
	 *  ^C}NɃRyÂŁCŒlݒ肷D
	 */
	TA1 = (UINT16)( 1 );

}	/* InitCounterInt	*/

/*
 *  SignalCounterspݒ~
 */
void
TermCounterInt( void )
{
	TA1IC = (UINT8)( 0 );	/* ݃}XN			*/
	TA1S = 0;				/* ^C}A1JEg~	*/
}	/* TermCounterInt	*/

/*
 *  SignalCountersp݋N
 */
void
ActCounterInt( void )
{
	/*
	 *  ^C}RyA݃xݒiݒ背x̓wb_QƁj
	 *  TA1IC  bit3 ݗvtOłCɃNAĂD
	 */
	TA1IC = CFG_INTLVL_COUNTER;
	TA1S = 1;	/* ^C}A1JEgJn	*/
}	/* ActCounterInt	*/

/*
 *  SignalCountersp݃T[rX[`
 */
ISR( CounterInt )
{
	StatusType ercd;

	/*
	 *  1̂ SignalCounter s߁C^C}~D
	 */
	TA1IC = (UINT8)( 0 );	/* ݃}XN			*/
	TA1S = 0;				/* ^C}A1JEg~	*/
	/*
	 *  JE^Zʒms
	 */
	ercd = SignalCounter( SampleCnt );
	/* G[^[̏ꍇ̓Vbg_E	*/
	if( ercd != E_OK ){
		ShutdownOS( ercd );
	}
}	/* ISR( CounterInt )	*/


/*
 *  ISR1EISR2ғmFp
 *
 *  s810-clg3-85ł̓^C}B0,B1ŎD
 */
/*
 *  n[hEFAJE^obt@
 */
static UINT8	hw_cnt1;
static UINT8	hw_cnt2;

/*
 *  ISR1EISR2JE^
 */
void
InitHwCntInt( void )
{
	/*
	 *  n[hEFAJE^
	 */
	hw_cnt1 = (UINT8)( 0 );
	hw_cnt2 = (UINT8)( 0 );

	/*
	 *  ^C}~ĊeWX^ݒ
	 */
	TB0S = 0;	/* JEg~	*/
	TB1S = 0;	/* JEg~	*/

	/*
	 *  ^C}[h, JEg\[Xf1
	 */
	TB0MR = (UINT8)( 0 );
	TB1MR = (UINT8)( 0 );

	/*
	 *  n[hEFAdlɂă^C}\[X̃WX^ݒl+1邽,
	 *  WX^ݒl̓VXeNbNɑJEg
	 *  }CiX1lݒ肷.iݒl̓wb_QƁj
	 */
	TB0 = CFG_HW_CNT1 - (UINT16)( 1 );
	TB1 = CFG_HW_CNT2 - (UINT16)( 1 );

	/*
	 *  ^C}RyA݃xݒiݒ背x̓wb_QƁj
	 *  TB0IC, TB1IC  bit3 ݗvtOłCɃNAĂD
	 */
	TB0IC = CFG_INTLVL_HW_CNT1;
	TB1IC = CFG_INTLVL_HW_CNT2;

	TB0S = 1;	/* JEgJn	*/
	TB1S = 1;	/* JEgJn	*/
}	/* InitHwCntInt	*/

/*
 *  ISR1EISR2JE^~
 */
void
TermHwCntInt( void )
{
	TB0IC = (UINT8)( 0 );	/* ݃}XN		*/
	TB1IC = (UINT8)( 0 );	/* ݃}XN		*/
	TB0S = 0;				/* JEg~		*/
	TB1S = 0;				/* JEg~		*/
}	/* TermHwCntInt	*/

/*
 *  ISR1EISR2JE^擾
 *
 *  hw_cnt1hw_cnt2̓擾͕ۏႵȂĂ悢i݋֎~͕svjD
 */
void
GetHwCnt( UINT8 *isr1_cnt, UINT8 *isr2_cnt )
{
	*isr1_cnt = hw_cnt1;
	*isr2_cnt = hw_cnt2;
}	/* GetHwCnt	*/

/*
 *  ISR1JE^Zp݃T[rX[`
 */
#if defined( OMIT_ISR1_ENTRY )
/* ISR1͖{֐݊֐w肷	*/
#pragma INTERRUPT	HwCnt1Int
#endif	/* OMIT_ISR1_ENTRY	*/
void	HwCnt1Int( void );
void
HwCnt1Int( void )
{
	hw_cnt1++;
}	/* HwCnt1Int	*/

/*
 *  ISR2JE^Zp݃T[rX[`
 */
ISR( HwCnt2Int )
{
	hw_cnt2++;
}	/* ISR( HwCnt2Int )	*/


