/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	TvVXe^C}W[
 */


#include	"hw_sys_timer.h"
#include	"sys_timer.h"


/*
 *  OIL`V{̊OQ
 */
DeclareCounter( SysTimerCnt );


/*
 *	֐vg^Cv錾
 */
ISR( SysTimerInt );


/*
 *  VXe^C}̋N
 *
 *  ݋֎~ԂŌďoƁD
 */
void
InitSysTimer( void )
{
	/*
	 *  ˑNs
	 */
	InitHwSysTimer();
}	/* InitSysTimer	*/

/*
 *  VXe^C}̒~
 *
 *  ݋֎~ԂŌďoƁD
 */
void
TermSysTimer( void )
{
	/*
	 *  ˑ~s
	 */
	TermHwSysTimer();
}	/* TermSysTimer	*/

/*
 *	VXe^C}[݃T[rX[`
 */
ISR( SysTimerInt )
{
	StatusType ercd;

	/*
	 *  ݗvtONA
	 */
	ClearHwSysTimerInt();

	/*
	 *  JE^Zʒms
	 */
	ercd = SignalCounter( SysTimerCnt );
	/* G[^[̏ꍇ̓Vbg_E	*/
	if( ercd != E_OK ){
		ShutdownOS( ercd );
	}
}	/* ISR( SysTimerInt )	*/


