/*
 *  TOPPERS/OSEK COM
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK COM
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	݊Ǘ@\
 */
#ifndef _COM_INTERRUPT_H_
#define _COM_INTERRUPT_H_

#include "osek_com.h"

/*
 *  }N
 */
/* NeBJZNV擾										*/
/* ̃}Nł͑ΉOST[rXR[							*/
/* (SuspendAllInterrupts)LڂD								*/
/* OSgp͎삵Ă炤D									*/
/* ݋֎~Ԃ擾APITOPPERS/OSEK OSł̂݃T|[gD	*/
/*   |[^reBł͖肾C̕@ŗǂƎvD			*/
/*     OSEK-OSŖ{COMgplɂ́CgĂ炤D		*/
/*     TOPPERS/OSEK COM͏L|V[ō쐬D					*/
#define ENTER_CRITICALSECTION()	SuspendAllInterrupts()

#define LEAVE_CRITICALSECTION()	ResumeAllInterrupts()

/* OS̊荞ݏԃ`FbN */
/* {֎~APICALLĂ͂Ȃ						*/
/* ɗ͏ɂ邽ߊԂ̃`FbNsD 				*/
/* TOPPERS/OSEK OS Release 1.0gpOSEK OSdlO				*/
/*   Ԏ擾APICALLD									*/
/* LȊȌꍇ̓`FbNsȂ悤ɂ邩					*/
/*   ̃`FbNɑ̂ʓrpӂD						*/
/*   `FbNsȂꍇC荞݋֎~APICALLȂ悤	*/
/*     [U[ɍŐV̒ӂ𕥂Ă炤D							*/
#define CHECK_INTERRUPT()

#endif /* _COM_INTERRUPT_H_ */
