/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	^[QbgVXeɈˑ`iS810-CLG3-85pj
 */

#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/* 
 *  J[lXe[^X^Cv̒`
 *
 *  L`Lɂ邱ƂŁCOSEKdl̊gG[`FbN𖳌łD
 */
/*#define BASIC_STATUS	*/

/* 
 *  ^[Qbgʃ}N(VXe̒`)
 */
#define S810-CLG3-85

/*
 *  NbZ[W̃^[QbgVXe
 */
#define	TARGET_NAME		(const UINT8 *)"M32C/S810-CLG3-85"

/*
 *  VXeŎgpvZbT̎
 *  144słgpꍇ SYS_MCU_M30855`
 *  100słgpꍇ SYS_MCU_M30853`
 */
/*#define	SYS_MCU_M30855	*/
#define	SYS_MCU_M30853


/*
 *  ݔԍ̒`
 */
#define	INT_BRKV		0		/* BRK	*/
#define	INT_DMA0		8		/* DMA0	*/
#define	INT_DMA1		9		/* DMA1	*/
#define	INT_DMA2		10		/* DMA2	*/
#define	INT_DMA3		11		/* DMA3	*/
#define	INT_TA0			12		/* ^C}A0	*/
#define	INT_TA1			13		/* ^C}A1	*/
#define	INT_TA2			14		/* ^C}A2	*/
#define	INT_TA3			15		/* ^C}A3	*/
#define	INT_TA4			16		/* ^C}A4	*/
#define	INT_S0TNACK		17		/* NACK	*/
#define	INT_S0RACK		18		/* ACK	*/
#define	INT_S1TNACK		19		/* NACK	*/
#define	INT_S1RACK		20		/* ACK	*/
#define	INT_UART0TX		17		/* UART0M	*/
#define	INT_UART0RX		18		/* UART0M	*/
#define	INT_UART1TX		19		/* UART1M	*/
#define	INT_UART1RX		20		/* UART1M	*/
#define	INT_TB0			21		/* ^C}B0	*/
#define	INT_TB1			22		/* ^C}B1	*/
#define	INT_TB2			23		/* ^C}B2	*/
#define	INT_TB3			24		/* ^C}B3	*/
#define	INT_TB4			25		/* ^C}B4	*/
#define	INT_INT5		26		/* INT5	*/
#define	INT_INT4		27		/* INT4	*/
#define	INT_INT3		28		/* INT3	*/
#define	INT_INT2		29		/* INT2	*/
#define	INT_INT1		30		/* INT1	*/
#define	INT_INT0		31		/* INT0	*/
#define	INT_TB5			32		/* ^C}B5	*/
#define	INT_S2TNACK		33		/* NACK	*/
#define	INT_S2RACK		34		/* ACK	*/
#define	INT_S3TNACK		35		/* NACK	*/
#define	INT_S3RACK		36		/* ACK	*/
#define	INT_S4TNACK 	37		/* NACK	*/
#define	INT_S4RACK		38		/* ACK	*/
#define	INT_UART2TX		33		/* UART2M	*/
#define	INT_UART2RX		34		/* UART2M	*/
#define	INT_UART3TX		35		/* UART3M	*/
#define	INT_UART3RX		36		/* UART3M	*/
#define	INT_UART4TX 	37		/* UART4M	*/
#define	INT_UART4RX		38		/* UART4M	*/
#define	INT_SSC2		39		/* oXՓˌo/X^[gRfBVo/XgbvRfBVo(UART2)/QG[	*/
#define	INT_SSC30		40		/* oXՓˌo/X^[gRfBVo/XgbvRfBVo(UART3/UART0)/QG[	*/
#define	INT_SSC41		41		/* oXՓˌo/X^[gRfBVo/XgbvRfBVo(UART4/UART1)/QG[	*/
#define	INT_AD0			42		/* A/Dϊ0	*/
#define	INT_KEY			43		/* L[	*/
#define	INT_IIO0CAN3	44		/* CeWFgI/O0,CAN3	*/
#define	INT_IIO1CAN4	45		/* CeWFgI/O1,CAN4	*/
#define	INT_IIO2		46		/* CeWFgI/O2	*/
#define	INT_IIO3		47		/* CeWFgI/O3	*/
#define	INT_IIO4		48		/* CeWFgI/O4	*/
#define	INT_CAN5		49		/* CAN5	*/
#define	INT_IIO8		52		/* CeWFgI/O8	*/
#define	INT_IIO9CAN0	53		/* CeWFgI/O9,CAN0	*/
#define	INT_IIO10CAN1	54		/* CeWFgI/O10,CAN1	*/
#define	INT_CAN2		57		/* CAN2	*/
#define	INT_UDI			64		/* `	*/
#define	INT_OVF			65		/* I[o[t[	*/
#define	INT_BLKF		66		/* BRK	*/
#define	INT_ADR			67		/* AhXv	*/
#define	INT_WDT			69		/* Ď^C}/U~o	*/
#define	INT_NMI			71		/* NMI	*/
#define	INT_RESET		72		/* Zbg	*/


#endif /* _SYS_DEFS_H_ */
