/*
 *	TOPPERS/Non-OS CAN Middleware DRV
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Non-OS CAN Middleware DRV
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 0.01  2007.04.04
 */

#ifndef __CAN_DRV_CSE_H_INCLUDE__
#define __CAN_DRV_CSE_H_INCLUDE__
/*---------------------------------------------------------------------------*/
/* 萔`                                                                  */
/*---------------------------------------------------------------------------*/
/* CAN{[[g萔 */
#define CAN_DRV_250KBPS         (0)         /* ʐMx 250Kbps              */
#define CAN_DRV_500KBPS         (1)         /* ʐMx 500Kbps              */

/* CPUNbN萔 */
#define CAN_DRV_CLK_20MHZ       (0)         /* CAN CLK 20MHz                 */
#define CAN_DRV_CLK_30MHZ       (1)         /* CAN CLK 30MHz                 */
#define CAN_DRV_CLK_32MHZ       (2)         /* CAN CLK 32MHz                 */

/* CANrbg^C~O萔 */
#define CAN_DRV_16TQ            (0)         /* rbg^C~O 16Tq         */
#define CAN_DRV_20TQ            (1)         /* rbg^C~O 20Tq         */

/* CANgp|[g萔 */
#define CAN_DRV_USE_P76         (0)         /* CAN|[gP76                  */
#define CAN_DRV_USE_P82         (1)         /* CAN|[gP82                  */
#define CAN_DRV_USE_P96         (2)         /* CAN|[gP96                  */
#define CAN_DRV_USE_P77         (3)         /* CAN|[gP77                  */
#define CAN_DRV_USE_P83         (4)         /* CAN|[gP83                  */
#define CAN_DRV_USE_P95         (5)         /* CAN|[gP95                  */

#define CAN_DRV_CH0   (0)                   /* ch0I                       */
#define CAN_DRV_CH1   (1)                   /* ch1I                       */

#endif /* __CAN_DRV_CSE_H_INCLUDE__ */
