/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2004-2007 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/* 
 *  TvvO(1)̖{
 *
 *  OSEK COM̊{IȓmF邽߂̃TvvOD
 *
 *  vO̊TvFPCƃ{[hԂŃVAʐMsCCANoXɂ
 *  ΌʐMɂāCԃ[U̓R}hɉƃOo͂
 *  sȂD
 *
 *  R}hꗗ
 *  EMf[^p^[w
 *    '1' : ȍ~̑MR}hł̓f[^p^[1gpD
 *    '2' : ȍ~̑MR}hł̓f[^p^[2gpD
 *    '3' : ȍ~̑MR}hł̓f[^p^[3gpD
 *    '4' : ȍ~̑MR}hł̓f[^p^[4gpD
 *    '5' : ȍ~̑MR}hł̓f[^p^[5gpD
 *  EʐM
 *    'z' : ʐMɂăbZ[W𑗐MD
 *    'a' : bZ[WL[ʐMbZ[WMD
 *    's' : ԃbZ[Wobt@bZ[WMD
 *    'q' : ʐMbZ[WL[̏Ԃ擾D
 *  EOŒ蒷ʐM
 *    'c' : OʐMɂČŒ蒷bZ[W𑗐MD
 *    'd' : bZ[WL[OʐM̌Œ蒷bZ[WMD
 *    'f' : ԃbZ[Wobt@OʐM̌Œ蒷bZ[WMD
 *    'w' : OʐMbZ[WL[̏Ԃ擾D
 *    'v' : IPDUɌŒ蒷bZ[Wݒ肷D
 *          f[^ʒuItZbgȂEoCgI[_[ϊD
 *    'b' : IPDUɌŒ蒷bZ[Wݒ肷D
 *          f[^ʒuItZbgEtB^ER[AEgE
 *          oCgI[_[ϊD
 *    'g' : ԃbZ[Wobt@OʐM̌Œ蒷bZ[WMD
 *          f[^ʒuItZbgȂEtB^ER[AEgE
 *          oCgI[_[ϊD
 *    'h' : ԃbZ[Wobt@OʐM̌Œ蒷bZ[WMD
 *          f[^ʒuItZbgEoCgI[_[ϊD
 *  EOϒʐM
 *    'n' : OʐMɂĉϒbZ[W𑗐MD
 *    'j' : OʐM̉ϒbZ[WMD
 *  ECOM
 *    'p' : COMW[ND
 *    'o' : COMW[~D
 *    'i' : COMND
 *    'u' : COM~D
 *  
 *  IuWFNgꗗ
 *  EOS
 *    X^[gAbvtbNFgp
 *    Vbg_EtbNFgp
 *    G[tbNFgp
 *    v^XNtbNFgp
 *    |Xg^XNtbNFgp
 *    XPW[\[XFgp
 *  EAvP[V[h
 *  [h1
 *    AvP[V[hIDFAppMode1
 *  E^XN
 *  C^XN
 *    ^XNIDFMainTask
 *    DxF10
 *    dNF1
 *    XPW[FmvGveBu
 *    NFAppMode1
 *    TvF[UC^tF[XiVAIOR}hMC
 *          ɑΉsȂDj
 *          A[ MainCycArm ɂC100msƂɑ҂
 *          R}h̎ML|[OD
 *          CxgiIDFMainEvtj֘AtĂD
 *  COMM^XN
 *    ^XNIDFCOMReceiveTask
 *    DxF12
 *    dNF3
 *    XPW[FmvGveBu
 *    NFȂ
 *    TvFCOM̎Ms^XND
 *          COMW[̃^XNłC[U瑀삵Ă͂ȂD
 *  E݃T[rX[`
 *  VAIOM
 *    ISRIDFRxHwSerialInt
 *    DxF6
 *    JeSF1
 *    TvFR}hMD
 *  VXe^C}
 *    ISRIDFSysTimerInt
 *    DxF4
 *    JeSF2
 *    TvFSignalCounter(SysTimerCnt) sD
 *  COMA[^C}
 *    ISRIDFCOMAlarmTimer
 *    DxF4
 *    JeSF2
 *    TvFCOM̎ĎsD
 *  ECxg
 *  C^XNCxg
 *    CxgIDFMainEvt
 *  EJE^
 *  VXe^C}JE^
 *    JE^IDFSysTimerCnt
 *    JEglF0`999
 *    ZlF1
 *  EA[
 *  CA[
 *    A[IDFMainCycArm
 *    x[XJE^IDFSysTimerCnt
 *    ANVFCxgݒ MainEvt
 *    NFAppMode1
 *    ݒFJE^100C100
 *  ECOM
 *    X^[gAbvgFgp
 *    COMG[tbNFgp
 *  EbZ[W
 *  MbZ[W
 *    bZ[WIDFSendInMsg
 *    f[^TCYF80bit
 *  ML[bZ[W
 *    bZ[WIDFRecvInQuMsg
 *    M郁bZ[WFSendInMsg
 *    L[TCYF4
 *    tB^F펞ʉ
 *    MʒmFNotifyRecvInQuR[obN
 *    MG[ʒmFȂ
 *  MԃbZ[W
 *    bZ[WIDFRecvInStMsg
 *    M郁bZ[WFSendInMsg
 *    tB^F펞ʉ
 *    MʒmFNotifyRecvInStR[obN
 *    MG[ʒmFȂ
 *  OŒ蒷MbZ[W1
 *    bZ[WIDFSendExFixMsg1
 *    f[^TCYF80bit
 *    tB^F펞ʉ
 *    Ώۃlbg[NbZ[WFSendFixTrgNMsg
 *    CPUR[AEgFȂ
 *    NWR[AEgFȂ
 *    MʒmFNotifySendExFix1R[obN
 *    MG[ʒmFȂ
 *  OŒ蒷ML[bZ[W
 *    bZ[WIDFRecvExQuMsg
 *    f[^TCYF80bit
 *    tB^F펞ʉ
 *    Ώۃlbg[NbZ[WFRecvFixNMsg1
 *    L[TCYF4
 *    CPUR[AEgFȂ
 *    NWR[AEgFȂ
 *    MʒmFNotifyRecvExFix1R[obN
 *    MG[ʒmFȂ
 *  OŒ蒷MԃbZ[W1
 *    bZ[WIDFRecvExStMsg1
 *    f[^TCYF80bit
 *    tB^F펞ʉ
 *    Ώۃlbg[NbZ[WFRecvFixNMsg1
 *    CPUR[AEgFȂ
 *    NWR[AEgFȂ
 *    MʒmFNotifyRecvExFix2R[obN
 *    MG[ʒmFȂ
 *  OŒ蒷MbZ[W2
 *    bZ[WIDFSendExFixMsg2
 *    f[^TCYF16bit
 *    tB^F펞ʉ
 *    Ώۃlbg[NbZ[WFSendFixPndNMsg1
 *    CPUR[AEgFȂ
 *    NWR[AEgFȂ
 *    MʒmFNotifySendExFix2R[obN
 *    MG[ʒmFȂ
 *  OŒ蒷MbZ[W3
 *    bZ[WIDFSendExFixMsg3
 *    f[^TCYF16bit
 *    tB^Ff[^ωoʉ
 *    Ώۃlbg[NbZ[WFSendFixPndNMsg2
 *    CPUR[AEgFSendExFixMsgCPUCb
 *    NWR[AEgFSendExFixMsgNWCb
 *    MʒmFNotifySendExFix3R[obN
 *    MG[ʒmFȂ
 *  OŒ蒷MԃbZ[W2
 *    bZ[WIDFRecvExStMsg2
 *    f[^TCYF16bit
 *    tB^Ff[^ωoʉ
 *    Ώۃlbg[NbZ[WFRecvFixNMsg2
 *    CPUR[AEgFRecvExStMsgCPUCb
 *    NWR[AEgFRecvExStMsgNWCb
 *    MʒmFNotifyRecvExFix3R[obN
 *    MG[ʒmFȂ
 *  OŒ蒷MԃbZ[W3
 *    bZ[WIDFRecvExStMsg3
 *    f[^TCYF16bit
 *    tB^F펞ʉ
 *    Ώۃlbg[NbZ[WFRecvFixNMsg3
 *    CPUR[AEgFȂ
 *    NWR[AEgFȂ
 *    MʒmFNotifyRecvExFix4R[obN
 *    MG[ʒmFȂ
 *  OϒMbZ[W
 *    bZ[WIDFSendExValMsg
 *    Ώۃlbg[NbZ[WFSendExValNMsg
 *    CPUR[AEgFȂ
 *    NWR[AEgFȂ
 *    MʒmFNotifySendExValR[obN
 *    MG[ʒmFȂ
 *  OϒMbZ[W
 *    bZ[WIDFRecvExValMsg
 *    Ώۃlbg[NbZ[WFRecvExValNMsg
 *    CPUR[AEgFȂ
 *    NWR[AEgFȂ
 *    MʒmFNotifyRecvExValR[obN
 *    MG[ʒmFȂ
 *  Elbg[NbZ[W
 *  Œ蒷gKMlbg[NbZ[W
 *    lbg[NbZ[WIDFSendFixTrgNMsg
 *    ΏIPDUFSendFixDirectIpdu
 *    f[^TCYF80bit
 *    IPDUł̃f[^ʒuItZbgF0bit
 *    f[^ߕ@FoCgziI[_[ϊȂj
 *    MvpeBFgK
 *  Œ蒷Mlbg[NbZ[W1
 *    lbg[NbZ[WIDFRecvFixNMsg1
 *    ΏIPDUFRecvFixNoTimeOutIpdu
 *    f[^TCYF80bit
 *    IPDUł̃f[^ʒuItZbgF0bit
 *    f[^ߕ@FoCgziI[_[ϊȂj
 *  Œ蒷yfBOMlbg[NbZ[W1
 *    lbg[NbZ[WIDFSendFixPndNMsg1
 *    ΏIPDUFSendFixPeriodicIpdu
 *    f[^TCYF16bit
 *    IPDUł̃f[^ʒuItZbgF0bit
 *    f[^ߕ@FȂiI[_[ϊj
 *    MvpeBFyfBO
 *  Œ蒷yfBOMlbg[NbZ[W2
 *    lbg[NbZ[WIDFSendFixPndNMsg2
 *    ΏIPDUFSendFixPeriodicIpdu
 *    f[^TCYF16bit
 *    IPDUł̃f[^ʒuItZbgF16bit
 *    f[^ߕ@FȂiI[_[ϊj
 *    MvpeBFyfBO
 *  Œ蒷Mlbg[NbZ[W2
 *    lbg[NbZ[WIDFRecvFixNMsg2
 *    ΏIPDUFRecvFixTimeOutIpdu
 *    f[^TCYF16bit
 *    IPDUł̃f[^ʒuItZbgF0bit
 *    f[^ߕ@FȂiI[_[ϊj
 *  Œ蒷Mlbg[NbZ[W3
 *    lbg[NbZ[WIDFRecvFixNMsg3
 *    ΏIPDUFRecvFixTimeOutIpdu
 *    f[^TCYF16bit
 *    IPDUł̃f[^ʒuItZbgF16bit
 *    f[^ߕ@FȂiI[_[ϊj
 *  ϒgKMlbg[NbZ[W
 *    lbg[NbZ[WIDFSendExValNMsg
 *    ΏIPDUFSendValDirectIpdu
 *    f[^TCYF80bit
 *    IPDUł̃f[^ʒuItZbgF0bit
 *    MvpeBFgK
 *  ϒMlbg[NbZ[W1
 *    lbg[NbZ[WIDFRecvExValNMsg
 *    ΏIPDUFRecvValNoTimeOutIpdu
 *    f[^TCYF80bit
 *    IPDUł̃f[^ʒuItZbgF0bit
 *  EIPDU
 *  Œ蒷_CNgMIPDU
 *    IPDU IDFSendFixDirectIpdu
 *    f[^TCYF80bit
 *    M[hF_CNg
 *    ŏfBCF100ms
 *    MfbhCF1000ms
 *    R[AEgFȂ
 *    MIDF0x401
 *  Œ蒷M^CAEgȂIPDU
 *    IPDU IDFRecvFixNoTimeOutIpdu
 *    f[^TCYF80bit
 *    MfbhCFȂ
 *    R[AEgFȂ
 *    MIDF0x201
 *  Œ蒷MIPDU
 *    IPDU IDFSendFixPeriodicIpdu
 *    f[^TCYF32bit
 *    M[hF
 *    MF3000ms
 *    MItZbgԁF1000ms
 *    MfbhCF1000ms
 *    R[AEgFȂ
 *    MIDF0x402
 *  Œ蒷M^CAEgIPDU
 *    IPDU IDFRecvFixTimeOutIpdu
 *    f[^TCYF32bit
 *    MfbhCF3500ms
 *    NMfbhCF5000ms
 *    R[AEgFȂ
 *    MIDF0x202
 *  ϒ_CNgMIPDU
 *    IPDU IDFSendValDirectIpdu
 *    f[^TCYF80bit
 *    M[hF_CNg
 *    ŏfBCF100ms
 *    MfbhCF1000ms
 *    R[AEgFȂ
 *    MIDF0x403
 *  ϒM^CAEgȂIPDU
 *    IPDU IDFRecvValNoTimeOutIpdu
 *    f[^TCYF80bit
 *    MfbhCFȂ
 *    R[AEgFȂ
 *    MIDF0x203
 *  ECANhCo
 *    {[[gF500Kbps
 *    MIDF0x201/0x202/0x203
 *
 */

#include "kernel.h"
#include "com.h"
#include "can_cmn.h" 
#include "can_drv_def.h"  /* DRV֘Aݒt@C                  */
#include "can_drv_ext.h"
#include "can_drv_csw.h"
#include "can_drv.h"
#include "sys_timer.h"
#include "serial.h"
#include "kernel_id.h"
#include "com_cfg.h"
#include "sample_config.h"

/*
 *  OIL`V{̊OQ
 */
DeclareTask( MainTask );
DeclareEvent( MainEvt );
DeclareAlarm( MainCycArm );

/*
 *	֐vg^Cv錾
 */
int main( void );
TASK( MainTask );
TASK(nm_ringmsg_task);
TASK(nm_configuration_task);
TASK(nm_status_task);

COMCallback( NotifyRecvInQu );
COMCallback( NotifyRecvInSt );
COMCallback( NotifySendExFix1 );
COMCallback( NotifyRecvExFix1 );
COMCallback( NotifyRecvExFix2 );
COMCallback( NotifySendExFix2 );
COMCallback( NotifySendExFix3 );
COMCallback( NotifyRecvExFix3 );
COMCallback( NotifyRecvExFix4 );
COMCallback( NotifySendExVal );
COMCallback( NotifyRecvExVal );
COMCallout( SendExFixMsgCPUCb );
COMCallout( SendExFixMsgNWCb );
COMCallout( RecvExStMsgCPUCb );
COMCallout( RecvExStMsgNWCb );
static UINT8	GetCommand( void );

/*
 *  萔f[^e[u
 */
/* G[e[u	*/
static const UINT8	*ercd_tbl[] = {
	"E_OK",						/* 0	*/
	"E_OS_ACCESS",				/* 1	*/
	"E_OS_CALLEVEL",			/* 2	*/
	"E_OS_ID",					/* 3	*/
	"E_OS_LIMIT",				/* 4	*/
	"E_OS_NOFUNC",				/* 5	*/
	"E_OS_RESOURCE",			/* 6	*/
	"E_OS_STATE",				/* 7	*/
	"E_OS_VALUE",				/* 8	*/
	"NO_ASSIGN",				/* 9	*/
	"NO_ASSIGN",				/* 10	*/
	"NO_ASSIGN",				/* 11	*/
	"NO_ASSIGN",				/* 12	*/
	"NO_ASSIGN",				/* 13	*/
	"NO_ASSIGN",				/* 14	*/
	"NO_ASSIGN",				/* 15	*/
	"NO_ASSIGN",				/* 16	*/
	"NO_ASSIGN",				/* 17	*/
	"NO_ASSIGN",				/* 18	*/
	"NO_ASSIGN",				/* 19	*/
	"NO_ASSIGN",				/* 20	*/
	"NO_ASSIGN",				/* 21	*/
	"NO_ASSIGN",				/* 22	*/
	"NO_ASSIGN",				/* 23	*/
	"NO_ASSIGN",				/* 24	*/
	"NO_ASSIGN",				/* 25	*/
	"NO_ASSIGN",				/* 26	*/
	"NO_ASSIGN",				/* 27	*/
	"NO_ASSIGN",				/* 28	*/
	"NO_ASSIGN",				/* 29	*/
	"NO_ASSIGN",				/* 30	*/
	"NO_ASSIGN",				/* 31	*/
	"E_COM_ID",					/* 32	*/
	"E_COM_LENGTH",				/* 33	*/
	"E_COM_LIMIT",				/* 34	*/
	"E_COM_NOMSG",				/* 35	*/
	"NO_ASSIGN",				/* 36	*/
	"NO_ASSIGN",				/* 37	*/
	"NO_ASSIGN",				/* 38	*/
	"NO_ASSIGN",				/* 39	*/
	"NO_ASSIGN",				/* 40	*/
	"NO_ASSIGN",				/* 41	*/
	"NO_ASSIGN",				/* 42	*/
	"NO_ASSIGN",				/* 43	*/
	"NO_ASSIGN",				/* 44	*/
	"NO_ASSIGN",				/* 45	*/
	"NO_ASSIGN",				/* 46	*/
	"NO_ASSIGN",				/* 47	*/
	"E_COM_SYS_STARTCOMEXT",	/* 48	*/
	"E_COM_SYS_CALLEVEL",		/* 49	*/
	"E_COM_SYS_INTERRUPT",		/* 50	*/
	"E_COM_SYS_ERR"				/* 51	*/
};

/* Mf[^e[u	*/
const static UINT8	SendData1[] = {
	0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88, 0x99, 0xaa };
const static UINT8	SendData2[] = {
	0xff, 0xee, 0xdd, 0xcc, 0xbb, 0xaa, 0x99, 0x88, 0x77, 0x66 };
const static UINT8	SendData3[] = {
	0x00, 0x22, 0x44, 0x66, 0x88, 0xaa, 0xcc, 0xee, 0x00, 0x22 };
const static UINT8	SendData4[] = {
	0xff, 0xdd, 0xbb, 0x99, 0x77, 0x55, 0x33, 0x11, 0xff, 0xdd };
const static UINT8	SendData5[] = {
	0x88, 0x79, 0x6a, 0x5b, 0x4c, 0x3d, 0x2e, 0x1f, 0x00, 0xf1 };

/* Mf[^p^[e[u	*/
const static UINT8	*SendDataTbl[5] = {
	SendData1,
	SendData2,
	SendData3,
	SendData4,
	SendData5
};

/* ϒMf[^p^[e[u	*/
const static COMLengthType	SendExValDlcTbl[5] = {
	10, 4, 8, 1, 7
};


/*
 *  [UC֐
 *
 *  AvP[V[h̔fƁCJ[lND
 */
int main( void )
{
	/*
	 *  J[lN
	 */
	StartOS( AppMode1 );

	while( 1 );

	return 1;
}	/* main	*/


/*
 *  C^XN
 *
 *  [UR}h̎MƁCR}hƂ̏sD
 */
TASK( MainTask )
{
	UINT8		command;			/* MR}hobt@			*/
	UINT8		data_no;			/* f[^Mp^[ԍ		*/
	UINT8		echo[] = { " \r\n" };
	UINT8		command_error[] = { "Not ASCII character\r\n" };
	InMsgType	in_msg_recv_buf;	/* bZ[WMobt@	*/
	ExMsgType	ex_st1_recv_buf;	/* OŒ蒷1Mobt@		*/
	UINT16		ex_st2_recv_buf;	/* OŒ蒷2Mobt@		*/
	UINT16		ex_st3_recv_buf;	/* OŒ蒷3Mobt@		*/
	UINT8		ex_dyn_recv_buf[10];	/* OϒMobt@	*/
	UINT8		recv_dlc;			/* Mf[^擾obt@		*/
	UINT8		*output_pt;			/* Mf[^o̓|C^		*/
	UINT8		out_data_cnt;		/* Oo̓f[^JE^		*/
	UINT8		str_buf[16];		/* O񐶐obt@		*/
	StatusType	ercd;				/* API߂l					*/

	/*
	 *  bZ[Wԍ
	 */
	data_no = (UINT8)( 0 );

	/*
	 *  R}hs[v
	 */
	while( 1 ){

		WaitEvent( MainEvt );	/* 100ms̍Ǝԑ҂	*/
		ClearEvent( MainEvt );

		/*
		 *  ̓R}h擾
		 */
		PutSysLog( (const UINT8 *)"Input Command:" );
		command = GetCommand();

		/*
		 *  ̓R}h`FbN
		 */
		if( ( command <= (UINT8)( 0x1f ) ) || ( command >= (UINT8)( 0x80 ) ) ){
			PutSysLog( (const UINT8 *)command_error );
		}
		else{
			echo[0] = command;
			PutSysLog( (const UINT8 *)echo );

			/*
			 *  R}h
			 */
			switch( command ){
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
				/*
				 *  Mf[^ԍip^[j̕ύX
				 */
				data_no = (UINT8)( command - '1' );
				break;
			case 'z':
				PutSysLog( (const UINT8 *)"SendMessage( SendInMsg, 0x" );
				output_pt = (UINT8 *)SendDataTbl[data_no];
				for( out_data_cnt = 0;
					 out_data_cnt < sizeof(InMsgType);
					 out_data_cnt++ ){
					ConvByte2HexStr( str_buf, (UINT8)output_pt[out_data_cnt] );
					PutSysLog( (const UINT8 *)str_buf );
				}
				PutSysLog( (const UINT8 *)" )\r\n" );
				SendMessage( SendInMsg, (ApplicationDataRef)SendDataTbl[data_no] );
				break;
			case 'a':
				ercd = ReceiveMessage( RecvInQuMsg, (ApplicationDataRef)&in_msg_recv_buf );
				if( ( ercd == E_OK ) || ( ercd == E_COM_LIMIT ) ){
					PutSysLog( (const UINT8 *)"ReceiveMessage( RecvInQuMsg, 0x" );
					for( out_data_cnt = 0;
						 out_data_cnt < sizeof(InMsgType);
						 out_data_cnt++ ){
						ConvByte2HexStr( str_buf, (UINT8)(((UINT8*)&in_msg_recv_buf)[out_data_cnt]) );
						PutSysLog( (const UINT8 *)str_buf );
					}
					PutSysLog( (const UINT8 *)" )\r\n" );
				}
				else if( ercd == E_COM_NOMSG ){
					PutSysLog( (const UINT8 *)"E_COM_NOMSG = ReceiveMessage( RecvInQuMsg )\r\n" );
				}
				break;
			case 's':
				ercd = ReceiveMessage( RecvInStMsg, (ApplicationDataRef)&in_msg_recv_buf );
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"ReceiveMessage( RecvInStMsg, 0x" );
					for( out_data_cnt = 0;
						 out_data_cnt < sizeof(InMsgType);
						 out_data_cnt++ ){
						ConvByte2HexStr( str_buf, (UINT8)(((UINT8*)&in_msg_recv_buf)[out_data_cnt]) );
						PutSysLog( (const UINT8 *)str_buf );
					}
					PutSysLog( (const UINT8 *)" )\r\n" );
				}
				break;
			case 'q':
				ercd = GetMessageStatus( RecvInQuMsg );
				PutSysLog( (const UINT8 *)"Message Queue Status:" );
				PutSysLog( ercd_tbl[ercd] );
				PutSysLog( (const UINT8 *)"\r\n" );
				break;
			case 'c':
				PutSysLog( (const UINT8 *)"SendMessage( SendExFixMsg1, 0x" );
				output_pt = (UINT8 *)SendDataTbl[data_no];
				for( out_data_cnt = 0;
					 out_data_cnt < sizeof(ExMsgType);
					 out_data_cnt++ ){
					ConvByte2HexStr( str_buf, (UINT8)output_pt[out_data_cnt] );
					PutSysLog( (const UINT8 *)str_buf );
				}
				PutSysLog( (const UINT8 *)" )\r\n" );
				SendMessage( SendExFixMsg1, (ApplicationDataRef)SendDataTbl[data_no] );
				break;
			case 'd':
				ercd = ReceiveMessage( RecvExQuMsg, (ApplicationDataRef)&ex_st1_recv_buf );
				if( ( ercd == E_OK ) || ( ercd == E_COM_LIMIT ) ){
					PutSysLog( (const UINT8 *)"ReceiveMessage( RecvExQuMsg, 0x" );
					for( out_data_cnt = 0;
						 out_data_cnt < sizeof(ExMsgType);
						 out_data_cnt++ ){
						ConvByte2HexStr( str_buf, (UINT8)(((UINT8*)&ex_st1_recv_buf)[out_data_cnt]) );
						PutSysLog( (const UINT8 *)str_buf );
					}
					PutSysLog( (const UINT8 *)" )\r\n" );
				}
				else if( ercd == E_COM_NOMSG ){
					PutSysLog( (const UINT8 *)"E_COM_NOMSG = ReceiveMessage( RecvExQuMsg )\r\n" );
				}
				break;
			case 'f':
				ercd = ReceiveMessage( RecvExStMsg1, (ApplicationDataRef)&ex_st1_recv_buf );
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"ReceiveMessage( RecvExStMsg1, 0x" );
					for( out_data_cnt = 0;
						 out_data_cnt < sizeof(ExMsgType);
						 out_data_cnt++ ){
						ConvByte2HexStr( str_buf, (UINT8)(((UINT8*)&ex_st1_recv_buf)[out_data_cnt]) );
						PutSysLog( (const UINT8 *)str_buf );
					}
					PutSysLog( (const UINT8 *)" )\r\n" );
				}
				break;
			case 'v':
				PutSysLog( (const UINT8 *)"SendMessage( SendExFixMsg2, 0x" );
				output_pt = (UINT8 *)SendDataTbl[data_no];
				for( out_data_cnt = 0;
					 out_data_cnt < sizeof(UINT16);
					 out_data_cnt++ ){
					ConvByte2HexStr( str_buf, (UINT8)output_pt[out_data_cnt] );
					PutSysLog( (const UINT8 *)str_buf );
				}
				PutSysLog( (const UINT8 *)" )\r\n" );
				SendMessage( SendExFixMsg2, (ApplicationDataRef)SendDataTbl[data_no] );
				break;
			case 'b':
				PutSysLog( (const UINT8 *)"SendMessage( SendExFixMsg3, 0x" );
				output_pt = (UINT8 *)SendDataTbl[data_no];
				for( out_data_cnt = 0;
					 out_data_cnt < sizeof(UINT16);
					 out_data_cnt++ ){
					ConvByte2HexStr( str_buf, (UINT8)output_pt[out_data_cnt] );
					PutSysLog( (const UINT8 *)str_buf );
				}
				PutSysLog( (const UINT8 *)" )\r\n" );
				SendMessage( SendExFixMsg3, (ApplicationDataRef)SendDataTbl[data_no] );
				break;
			case 'g':
				ercd = ReceiveMessage( RecvExStMsg2, (ApplicationDataRef)&ex_st2_recv_buf );
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"ReceiveMessage( RecvExStMsg2, 0x" );
					ConvShort2HexStr( str_buf, ex_st2_recv_buf );
					PutSysLog( (const UINT8 *)str_buf );
					PutSysLog( (const UINT8 *)" )\r\n" );
				}
				break;
			case 'h':
				ercd = ReceiveMessage( RecvExStMsg3, (ApplicationDataRef)&ex_st3_recv_buf );
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"ReceiveMessage( RecvExStMsg3, 0x" );
					ConvShort2HexStr( str_buf, ex_st3_recv_buf );
					PutSysLog( (const UINT8 *)str_buf );
					PutSysLog( (const UINT8 *)" )\r\n" );
				}
				break;
			case 'w':
				ercd = GetMessageStatus( RecvExQuMsg );
				PutSysLog( (const UINT8 *)"Message Queue Status:" );
				PutSysLog( ercd_tbl[ercd] );
				PutSysLog( (const UINT8 *)"\r\n" );
				break;
			case 'n':
				PutSysLog( (const UINT8 *)"SendDynamicMessage( SendExValMsg, 0x" );
				output_pt = (UINT8 *)SendDataTbl[data_no];
				for( out_data_cnt = 0;
					 out_data_cnt < SendExValDlcTbl[data_no];
					 out_data_cnt++ ){
					ConvByte2HexStr( str_buf, (UINT8)output_pt[out_data_cnt] );
					PutSysLog( (const UINT8 *)str_buf );
				}
				PutSysLog( (const UINT8 *)", " );
				ConvByte2DecStr( str_buf, SendExValDlcTbl[data_no] );
				PutSysLog( (const UINT8 *)str_buf );
				PutSysLog( (const UINT8 *)" )\r\n" );
				SendDynamicMessage( SendExValMsg,
									(ApplicationDataRef)SendDataTbl[data_no],
									(LengthRef)&SendExValDlcTbl[data_no] );
				break;
			case 'j':
				ercd = ReceiveDynamicMessage( RecvExValMsg,
											  (ApplicationDataRef)ex_dyn_recv_buf,
											  (LengthRef)&recv_dlc );
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"ReceiveDynamicMessage( RecvExValMsg, 0x" );
					for( out_data_cnt = 0;
						 out_data_cnt < recv_dlc;
						 out_data_cnt++ ){
						ConvByte2HexStr( str_buf, (UINT8)ex_dyn_recv_buf[out_data_cnt] );
						PutSysLog( (const UINT8 *)str_buf );
					}
					PutSysLog( (const UINT8 *)", " );
					ConvByte2DecStr( str_buf, recv_dlc );
					PutSysLog( (const UINT8 *)str_buf );
					PutSysLog( (const UINT8 *)" )\r\n" );
				}
				break;
			case 'p':
				ercd = StartCOM( ComNormalMode );
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"COM start\r\n" );
				}
				break;
			case 'o':
				ercd = StopCOM( COM_SHUTDOWN );
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"COM shutdown\r\n" );
				}
				break;
			case 'i':
				ercd = StartPeriodic();
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"Start periodic exec\r\n" );
				}
				break;
			case 'u':
				ercd = StopPeriodic();
				if( ercd == E_OK ){
					PutSysLog( (const UINT8 *)"Stop periodic exec\r\n" );
				}
				break;
			default:
				PutSysLog( (const UINT8 *)"The command is unsupport\r\n" );
				break;
			}
		}
	}

	/*
	 *  ɂ͂ȂD
	 */
	PutSysLog( (const UINT8 *)"MainTask TERMINATE\r\n" );
	TerminateTask();
}	/* TASK( MainTask )	*/


/*
 *  R}hM
 */
static UINT8
GetCommand( void )
{
	UINT8		command;	/* R}hMobt@	*/

	/*
	 *  R}hM܂Ń[v
	 */
	command = '\0';
	do{
		WaitEvent( MainEvt );	/* 100msEFCg	*/
		ClearEvent( MainEvt );
		RecvPolSerialChar( &command );	/* Mobt@|[O	*/
	} while( command == '\0' );

	return command;
}	/* GetCommand	*/


/*
 *  COMG[tbN[`
 */
void COMErrorHook( StatusType ercd )
{
	UINT8	str_buf[16];	/* O񐶐obt@	*/

	/*
	 *  G[R[hOo
	 */
	PutSysLog( (const UINT8 *)"Error:" );
	PutSysLog( ercd_tbl[ercd] );

	/*
	 *  G[vƂ̃p[^Oo
	 */
	switch( COMErrorGetServiceId() ){
	case COMServiceId_StartCOM:
		PutSysLog( (const UINT8 *)"=StartCOM(" );
		if( ComNormalMode == COMError_StartCOM_Mode() ){
			PutSysLog( (const UINT8 *)"ComNormalMode" );
		}
		else{
			PutSysLog( (const UINT8 *)"UnknownMode" );
		}
		break;
	case COMServiceId_StopCOM:
		PutSysLog( (const UINT8 *)"=StopCOM(" );
		if( COM_SHUTDOWN == COMError_StopCOM_Mode() ){
			PutSysLog( (const UINT8 *)"COM_SHUTDOWN" );
		}
		else{
			PutSysLog( (const UINT8 *)"UnknownMode" );
		}
		break;
	case COMServiceId_GetCOMApplicationMode:
		PutSysLog( (const UINT8 *)"=GetCOMApplicationMode(" );
		break;
	case COMServiceId_InitMessage:
		PutSysLog( (const UINT8 *)"=InitMessage(0x" );
		ConvShort2HexStr( str_buf, COMError_InitMessage_Message() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)", 0x" );
		ConvLong2HexStr( str_buf, (UINT32)COMError_InitMessage_DataRef() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case COMServiceId_StartPeriodic:
		PutSysLog( (const UINT8 *)"=StartPeriodic(" );
		break;
	case COMServiceId_StopPeriodic:
		PutSysLog( (const UINT8 *)"=StopPeriodic(" );
		break;
	case COMServiceId_ReadFlag:
		PutSysLog( (const UINT8 *)"=ReadFlag(" );
		break;
	case COMServiceId_ResetFlag:
		PutSysLog( (const UINT8 *)"=ResetFlag(" );
		break;
	case COMServiceId_SendMessage:
		PutSysLog( (const UINT8 *)"=SendMessage(0x" );
		ConvShort2HexStr( str_buf, COMError_SendMessage_Message() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)", 0x" );
		ConvLong2HexStr( str_buf, (UINT32)COMError_SendMessage_DataRef() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case COMServiceId_ReceiveMessage:
		PutSysLog( (const UINT8 *)"=ReceiveMessage(0x" );
		ConvShort2HexStr( str_buf, COMError_ReceiveMessage_Message() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)", 0x" );
		ConvLong2HexStr( str_buf, (UINT32)COMError_ReceiveMessage_DataRef() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case COMServiceId_SendDynamicMessage:
		PutSysLog( (const UINT8 *)"=SendDynamicMessage(0x" );
		ConvShort2HexStr( str_buf, COMError_SendDynamicMessage_Message() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)", 0x" );
		ConvLong2HexStr( str_buf, (UINT32)COMError_SendDynamicMessage_DataRef() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)", 0x" );
		ConvLong2HexStr( str_buf, (UINT32)COMError_SendDynamicMessage_LengthRef() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case COMServiceId_ReceiveDynamicMessage:
		PutSysLog( (const UINT8 *)"=ReceiveDynamicMessage(0x" );
		ConvShort2HexStr( str_buf, COMError_ReceiveDynamicMessage_Message() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)", 0x" );
		ConvLong2HexStr( str_buf, (UINT32)COMError_ReceiveDynamicMessage_DataRef() );
		PutSysLog( (const UINT8 *)str_buf );
		PutSysLog( (const UINT8 *)", 0x" );
		ConvLong2HexStr( str_buf, (UINT32)COMError_ReceiveDynamicMessage_LengthRef() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case COMServiceId_SendZeroMessage:
		PutSysLog( (const UINT8 *)"=SendZeroMessage(0x" );
		ConvShort2HexStr( str_buf, COMError_SendZeroMessage_Message() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case COMServiceId_GetMessageStatus:
		PutSysLog( (const UINT8 *)"=GetMessageStatus(0x" );
		ConvShort2HexStr( str_buf, COMError_GetMessageStatus_Message() );
		PutSysLog( (const UINT8 *)str_buf );
		break;
	case COMServiceId_StartCOMExtension:
		PutSysLog( (const UINT8 *)"=StartCOMExtension(" );
		break;
	case COMServiceId_COMCallout:
		PutSysLog( (const UINT8 *)"=COMCallout(" );
		break;
	case COMServiceId_CallCOMSndMsgDRV:
		PutSysLog( (const UINT8 *)"=CallCOMSndMsgDRV(" );
		break;
	case COMServiceId_CallCOMRcvMsgDRV:
		PutSysLog( (const UINT8 *)"=CallCOMRcvMsgDRV(" );
		break;
	default:
		PutSysLog( (const UINT8 *)"=UnKnownFunc(" );
		break;
	}

	PutSysLog( (const UINT8 *)")\r\n" );
}	/* COMErrorHook	*/


/*
 *  G[tbN[`
 */
#ifdef USE_ERRORHOOK
void ErrorHook( StatusType ercd )
{
	/*
	 *  G[ɂȂVbg_E
	 */
	ShutdownOS( ercd );
}	/* ErrorHook	*/
#endif /* USE_ERRORHOOK */

/*
 *  v^XNtbN[`
 *
 *  {Tvł͖gpD
 */
#ifdef USE_PRETASKHOOK
void PreTaskHook( void )
{
}	/* PreTaskHook	*/
#endif /* USE_PRETASKHOOK */

/*
 *  |Xg^XNtbN[`
 *
 *  {Tvł͖gpD
 */
#ifdef USE_POSTTASKHOOK
void PostTaskHook( void )
{
}	/* PostTaskHook	*/
#endif /* USE_POSTTASKHOOK */

/*
 *  X^[gAbvtbN[`
 */
#ifdef USE_STARTUPHOOK
void StartupHook( void )
{
	InitSerial();		/* VAIOW[		*/
	/* NOo	*/
	PutIntSysLog( (UINT8 *)"\r\nCAN driver on TOPPERS/OSEK" );
#if defined( TARGET_NAME )
	PutIntSysLog( (UINT8 *)" for " );
	PutIntSysLog( (UINT8 *)TARGET_NAME );
#endif	/* TARGET_NAME	*/
	PutIntSysLog( (UINT8 *)"\r\nSample System StartUp\r\n\r\n" );

	FncChgModCAN( CAN_DRV_CAN_RESET );	/* CANhCoZbg	*/
	FncChgModCAN( CAN_DRV_CAN_RUN );	/* CANhCo쓮		*/
	InitSysTimer();		/* VXe^C}N				*/
}	/* StartupHook	*/
#endif /* USE_STARTUPHOOK */

/*
 *  Vbg_EtbN[`
 */
#ifdef USE_SHUTDOWNHOOK
void ShutdownHook( StatusType ercd )
{
	TermSysTimer();		/* VXe^C}~				*/
	FncChgModCAN( CAN_DRV_CAN_RESET );	/* CANhCoZbg	*/
	/* IOo	*/
	PutIntSysLog( (UINT8 *)"\r\nSample System ShutDown\r\nShutDownCode : " );
	PutIntSysLog( ercd_tbl[ercd] );
	PutIntSysLog( (UINT8 *)"\r\n\r\n" );
	TermSerial();		/* VAIOW[~			*/
}	/* ShutdownHook	*/
#endif /* USE_SHUTDOWNHOOK */

/*
 *  bZ[WL[MR[obN
 */
COMCallback( NotifyRecvInQu )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Recv Queued Internal\r\n" );
}	/* COMCallback( NotifyRecvInQu )	*/

/*
 *  bZ[WԎMR[obN
 */
COMCallback( NotifyRecvInSt )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Recv UnQueued Internal\r\n" );
}	/* COMCallback( NotifyRecvInQu )	*/

/*
 *  Œ蒷ObZ[WMR[obN1
 */
COMCallback( NotifySendExFix1 )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Send Static External 1\r\n" );
}	/* COMCallback( NotifySendExFix1 )	*/

/*
 *  Œ蒷ObZ[WMR[obN1
 */
COMCallback( NotifyRecvExFix1 )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Recv Static External 1\r\n" );
}	/* COMCallback( NotifyRecvExFix1 )	*/

/*
 *  Œ蒷ObZ[WMR[obN2
 */
COMCallback( NotifyRecvExFix2 )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Recv Static External 2\r\n" );
}	/* COMCallback( NotifyRecvExFix2 )	*/

/*
 *  Œ蒷ObZ[WMR[obN2
 */
COMCallback( NotifySendExFix2 )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Send Static External 2\r\n" );
}	/* COMCallback( NotifySendExFix2 )	*/

/*
 *  Œ蒷ObZ[WMR[obN3
 */
COMCallback( NotifySendExFix3 )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Send Static External 3\r\n" );
}	/* COMCallback( NotifySendExFix3 )	*/

/*
 *  Œ蒷ObZ[WMR[obN3
 */
COMCallback( NotifyRecvExFix3 )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Recv Static External 3\r\n" );
}	/* COMCallback( NotifyRecvExFix3 )	*/

/*
 *  Œ蒷ObZ[WMR[obN4
 */
COMCallback( NotifyRecvExFix4 )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Recv Static External 4\r\n" );
}	/* COMCallback( NotifyRecvExFix4 )	*/

/*
 *  ϒObZ[WMR[obN
 */
COMCallback( NotifySendExVal )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Send Dynamic External\r\n" );
}	/* COMCallback( NotifySendExVal )	*/

/*
 *  ϒObZ[WMR[obN
 */
COMCallback( NotifyRecvExVal )
{
	/*
	 *  R[obNsOo
	 */
	PutSysLog( (const UINT8 *)"Notify Recv Dynamic External\r\n" );
}	/* COMCallback( NotifyRecvExVal )	*/

/*
 *  Œ蒷ObZ[WM3CPUI[_[R[AEg
 */
COMCallout( SendExFixMsgCPUCb )
{
	/*
	 *  R[AEgsOo
	 */
	PutSysLog( (const UINT8 *)"CPU Order Send Data\r\n" );

	return COM_TRUE;	/* Ms	*/
}	/* SendExFixMsgCPUCb	*/

/*
 *  Œ蒷ObZ[WM3NetworkI[_[R[AEg
 */
COMCallout( SendExFixMsgNWCb )
{
	/*
	 *  R[AEgsOo
	 */
	PutSysLog( (const UINT8 *)"Network Order Send Data\r\n" );

	return COM_TRUE;	/* Ms	*/
}	/* SendExFixMsgNWCb	*/

/*
 *  Œ蒷ObZ[WM2CPUI[_[R[AEg
 */
COMCallout( RecvExStMsgCPUCb )
{
	/*
	 *  R[AEgsOo
	 */
	PutSysLog( (const UINT8 *)"CPU Order Recv Data\r\n" );

	return COM_TRUE;	/* Ms	*/
}	/* RecvExStMsgCPUCb	*/

/*
 *  Œ蒷ObZ[WM2NetworkI[_[R[AEg
 */
COMCallout( RecvExStMsgNWCb )
{
	/*
	 *  R[AEgsOo
	 */
	PutSysLog( (const UINT8 *)"Network Order Recv Data\r\n" );

	return COM_TRUE;	/* Ms	*/
}	/* RecvExStMsgNWCb	*/


TASK(nm_ringmsg_task){

	SendSerialStr("nm_ringmsg_task \r\n");
	
	//ActivateTask(Task1);
	//TerminateTask();
	
}

TASK(nm_configuration_task){

	SendSerialStr("nm_configuration_task \r\n");

	//ActivateTask(Task1);
	//TerminateTask();
}

TASK(nm_status_task){

	SendSerialStr("nm_status_task \r\n");

	//ActivateTask(Task1);
	//TerminateTask();
}

