/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	TvVAIOW[
 */


#if !defined( _SERIAL_H_ )
#define _SERIAL_H_


#include	"kernel.h"


/*
 *  VXeOo͊֐̃l[
 *  VXeOo͊֐̓VAM֐őpD
 */
/*
 *  񑗐M֐vg^Cv錾
 */
#define	PutSysLog	SendSerialStr

/*
 *  ݒ񑗐M֐vg^Cv錾
 */
#define	PutIntSysLog	SendIntSerialStr


#if !defined( _MACRO_ONLY )

/*
 *  VAIOW[֐vg^Cv錾
 */
extern void	InitSerial( void );

/*
 *  VAIOW[~֐vg^Cv錾
 */
extern void	TermSerial( void );

/*
 *  񑗐M֐vg^Cv錾
 */
extern void	SendSerialStr( const UINT8 * str );

/*
 *  ݒ񑗐M֐vg^Cv錾
 */
extern void	SendIntSerialStr( const UINT8 * str );

/*
 *  M֐vg^Cv錾
 */
extern void	RecvPolSerialChar( UINT8 * character );

/*
 *  32bitl -> 10iϊ֐vg^Cv錾
 */
extern void	ConvLong2DecStr( UINT8 *dst, UINT32 src );

/*
 *  16bitl -> 10iϊ֐
 */
extern void	ConvShort2DecStr( UINT8 *dst, UINT16 src );

/*
 *  8bitl -> 10iϊ֐
 */
extern void	ConvByte2DecStr( UINT8 *dst, UINT8 src );

/*
 *  32bitl -> 16iϊ֐
 */
extern void	ConvLong2HexStr( UINT8 *dst, UINT32 src );

/*
 *  16bitl -> 16iϊ֐
 */
extern void	ConvShort2HexStr( UINT8 *dst, UINT16 src );

/*
 *  8bitl -> 16iϊ֐
 */
extern void	ConvByte2HexStr( UINT8 *dst, UINT8 src );

#endif /* _MACRO_ONLY */


#endif /* _SERIAL_H_ */

